Unit SWCUtil;


{$F+}


Interface


Uses CRT,
     DOS,
     SWCLSN,
     SWCFNB,
     SWCSubPr,
     SWCVaria;




Procedure SWCAdjustMem;
Procedure SWCAdjustments;
Procedure SWCAdjustOPath;
Procedure SWCAdjustSeg;
Procedure SWCAdjustTrys;
Function  SWCDataKBGet: Bool;
Procedure SWCDiskFormat;
Procedure SWCDiskMake;
Procedure SWCDiskReadIn;
Procedure SWCImageLoad;
Procedure SWCImageSave;
Procedure SWCInfo;
Procedure SWCMainMenue;
Procedure SWCMakeHexLSN(HPath: ST79);
Procedure SWCMaxTrysGet;
Function  SWCOPathGet: ST79;
Procedure SWCSaveHexLSN(HPath: ST79);
Function  SWCSegLimitGet: Word;
Procedure SWCXMSEdit;




Implementation




Uses SWCDir,
     SWCMask,
     SWCMouse,
     SWCMskPx,
     SWCOpt,
     SWCPGX,
     SWCXMS,
     SWCZip;




Procedure HelpError(Error: Byte;LWB: Byte;Var BStop: Bool);          ForWard;
Procedure HelpErrorOut(Error: Byte;Var BStop: Bool);                 ForWard;
Function  HelpGetDTypAsString(DTyp0: DTyp): ST80;                    ForWard;
Procedure HelpReset(BDo: Bool;LWB: Byte;Var BStop: Bool);            ForWard;




Procedure HelpError(Error: Byte;LWB: Byte;Var BStop: Bool);
Begin

  BStop:=BF;
  If Error And BIOSErrNotAllowedFuncNo=BIOSErrNotAllowedFuncNo Then BStop:=BT;
  If Error And BIOSErrDMAOverRun=BIOSErrDMAOverRun Then BStop:=BT;
  If Error And BIOSErrDataOverRun=BIOSErrDataOverRun Then BStop:=BT;
  If Error And BIOSErrDiskControler=BIOSErrDiskControler Then BStop:=BT;
  If Error And BIOSErrTimeOut=BIOSErrTimeOut Then BStop:=BT;
  If Error<>000 Then
  Begin
    HelpReset(BF,LWB,BStop);
    HelpErrorOut(Error,BStop);
  End;

End;




Procedure HelpErrorOut(Error: Byte;Var BStop: Bool);
Var
  Erro2 : Byte;
  Stri0 : ST80;

Begin

  Repeat
    If Error And $01=$01 Then
    Begin
      Erro2:=$01;
      Error:=Error And (255-$01);
    End
    Else
    If Error And $02=$02 Then
    Begin
      Erro2:=$02;
      Error:=Error And (255-$02);
    End
    Else
    If Error And $03=$03 Then
    Begin
      Erro2:=$03;
      Error:=Error And (255-$03);
    End
    Else
    If Error And $04=$04 Then
    Begin
      Erro2:=$04;
      Error:=Error And (255-$04);
    End
    Else
    If Error And $08=$08 Then
    Begin
      Erro2:=$08;
      Error:=Error And (255-$08);
    End
    Else
    If Error And $09=$09 Then
    Begin
      Erro2:=$09;
      Error:=Error And (255-$09);
    End
    Else
    If Error And $10=$10 Then
    Begin
      Erro2:=$10;
      Error:=Error And (255-$10);
    End
    Else
    If Error And $20=$20 Then
    Begin
      Erro2:=$20;
      Error:=Error And (255-$20);
    End
    Else
    If Error And $40=$40 Then
    Begin
      Erro2:=$40;
      Error:=Error And (255-$40);
    End
    Else
    If Error And $80=$80 Then
    Begin
      Erro2:=$80;
      Error:=Error And (255-$80);
    End;
    Case Erro2 Of
    $01 : Stri0:='BIOSErrNotAllowedFuncNo';
    $02 : Stri0:='BIOSErrAdrMarkNotFound';
    $03 : Stri0:='BIOSErrWriteProtected';
    $04 : Stri0:='BIOSErrSectrNotFound';
    $08 : Stri0:='BIOSErrDMAOverRun';
    $09 : Stri0:='BIOSErrDataOverRun';
    $10 : Stri0:='BIOSErrReadError';
    $20 : Stri0:='BIOSErrDiskControler';
    $40 : Stri0:='BIOSErrTrackNotFound';
    $80 : Stri0:='BIOSErrTimeOut';
    End;
    ErrorOut(Stri0+'. Was nun ?',000,'~Weiter~Stop','W');
    If Char0='S' Then BStop:=BT;
    If Char0='W' Then BStop:=BF;
  Until (Error=000) Or BStop;

End;




Function  HelpGetDTypAsString(DTyp0: DTyp): ST80;
Begin

  HelpGetDTypAsString:='';
  Case DTyp0 Of
  DT288 : HelpGetDTypAsString:='3 1/2"  2.88 MB';
  DT144 : HelpGetDTypAsString:='3 1/2"  1.44 MB';
  DT720 : HelpGetDTypAsString:='3 1/2"  720 KB';
  DT12  : HelpGetDTypAsString:='5 1/4"  1.2 MB';
  DT360 : HelpGetDTypAsString:='5 1/4"  360 KB';
  DT320 : HelpGetDTypAsString:='5 1/4"  320 KB';
  DTNone: HelpGetDTypAsString:='unbekannt';
  End;

End;




Procedure HelpGetParameters(DTyp0: DTyp;Var MaxDS,MaxTr,MaxSe: Byte);
Begin

  Case DTyp0 Of
  DT288 : Begin
            MaxDS:=001;
            MaxTr:=080;
            MaxSe:=036;
          End;
  DT144 : Begin
            MaxDS:=001;
            MaxTr:=080;
            MaxSe:=018;
          End;
  DT12  : Begin
            MaxDS:=001;
            MaxTr:=080;
            MaxSe:=015;
          End;
  DT720 : Begin
            MaxDS:=001;
            MaxTr:=080;
            MaxSe:=009;
          End;
  DT360 : Begin
            MaxDS:=001;
            MaxTr:=040;
            MaxSe:=009;
          End;
  DT320 : Begin
            MaxDS:=001;
            MaxTr:=040;
            MaxSe:=008;
          End;
  End;

End;




Procedure HelpGetSetIntVecsOff;
Begin

  SetIntVec($1E,ODDPT);

End;




Procedure HelpGetSetIntVecsOn(DTypX: DTyp);
Begin

  GetIntVec($1E,ODDPT);
  Exit;
  Case DTypX Of
  DT288 : SetIntVec($1E,@DDPT1440);
  DT144 : SetIntVec($1E,@DDPT1440);
  DT12  : SetIntVec($1E,@DDPT1200);
  DT720 : SetIntVec($1E,@DDPT720);
  DT360 : SetIntVec($1E,@DDPT360);
  DT320 : SetIntVec($1E,@DDPT360);
  End;

End;




Function  HelpReadWriteDisk(Func: Byte;LWB: Byte;DSide: Byte;BufSeg: Word;
          Track: Byte;NumSec: Byte;CntSec: Byte;BufOfs: Word;
          MaxSe: Byte;BPSec: Word;Var BStop,BStart: Bool): Byte;
Var
  Stri0 : ST80;
  Stri1 : ST80;
  Stri2 : ST80;
  Stri3 : ST80;
  Stri4 : ST80;
  Stri5 : ST80;
  Try   : Byte;

Begin

  If BStart Then
  Begin
    BStart:=BF;
    OptTableau3(025,001,026,006,'',BF);
  End;
  Try:=000;
  Repeat
    RegAH:=Func;
    RegAL:=CntSec;
    RegBX:=BufOfs;
    RegCH:=Track;
    RegCL:=NumSec;
    RegES:=BufSeg;
    RegDH:=DSide;
    RegDL:=LWB-001;
    Str(DSide,Stri4);
    Str(Track,Stri1);
    Str(MaxSe,Stri2);
    Str(BPSec,Stri5);
    Str(NumSec:002,Stri3);
    Case Func Of
    $02 : Stri0:='Lesen';
    $03 : Stri0:='Schreiben';
    $05 : Stri0:='Formatieren';
    End;
    Stri0:='Funktion: '+Stri0;
    Stri4:='Diskseite: '+Stri4;
    Stri1:='Track: '+Stri1;
    Stri3:='Sektor: '+Stri3;
    Stri2:='Sektoren pro Track: '+Stri2;
    Stri5:='Bytes pro Sektor: '+Stri5;
    WaitForVerticalRetrace;
    WriteVR(Stri0,027+(026-Length(Stri0)) Div 002,003);
    WriteVR(Stri4,027+(026-Length(Stri4)) Div 002,004);
    WriteVR(Stri1,027+(026-Length(Stri1)) Div 002,005);
    WriteVR(Stri3,027+(026-Length(Stri3)) Div 002,006);
    WriteVR(Stri2,027+(026-Length(Stri2)) Div 002,007);
    WriteVR(Stri5,027+(026-Length(Stri5)) Div 002,008);
    ASM
      Mov AH,RegAH
      Mov AL,RegAL
      Mov DL,RegDL
      Mov DH,RegDH
      Mov CH,RegCH
      Mov CL,RegCL
      Mov ES,RegES
      Mov BX,RegBX
      Int $13
      PushF
      Pop RegFL
      Mov RegAH,AH
      Mov RegAL,AL
    End;
    If MyKeyPressed Then
    Begin
      Wait;
      If BooleanEx Then
      Begin
        Case Func Of
        $02 : Stri0:='Leseproze';
        $03 : Stri0:='Schreibproze';
        $05 : Stri0:='Formatierung';
        End;
        OptionsR(000,000,
        Stri0+' abbrechen ?',
        '~Ja~Nein','N',BT);
        If Char0='J' Then BStop:=BT;
      End;
    End;
    If RegFL And FCarry=001 Then
    HelpReset(BF,LWB,BStop);
    If (RegFL And FCarry=001)
    Or ((RegFL And FCarry=000) And (RegAL<CntSec)) Then Inc(Try);
  Until (RegFL And FCarry=000)
  Or ((RegFL And FCarry=001) And (Try=MaxTrys)) Or BStop;
  If RegFL And FCarry=000 Then
  HelpReadWriteDisk:=RegAL
  Else
  Begin
    HelpReset(BF,LWB,BStop);
    HelpError(RegAH,LWB,BStop);
    HelpReadWriteDisk:=000;
  End;

End;




Procedure HelpReset(BDo: Bool;LWB: Byte;Var BStop: Bool);
Var
  RFL2  : Word;
  Try   : Byte;

Begin

  Try:=000;
  RFL2:=RegFL;
  RegDL:=LWB-001;
  Repeat
    ASM
      Mov AH,$00
      Mov DL,RegDL
      Int $13
      PushF
      Pop RegFL
    End;
    Inc(Try);
  Until (RegFL And FCarry=000) Or (Try=MaxTrys);
  If BDo Then
  If RegFL And FCarry=000 Then
  BStop:=BF
  Else
  BStop:=BT;
  RegFL:=RFL2;

End;




Procedure HelpSetFormat(DTypX: DTyp;LWB: Byte);
Var
  RFL2  : Word;

Procedure HelpReset;
Begin
  RFL2:=RegFL;
  RegDL:=LWB-001;
  ASM
    @LOOP:
    Mov  AH,$00
    Mov  DL,RegDL
    Int  $13
    JC   @LOOP
    PushF
    Pop  RegFL
  End;
  RegFL:=RFL2;
End;

Begin

  Case DTypX Of
  DT288 : Begin
            RegCH:=079;  {Grte Spurnummer}
            RegCL:=036;  {Grte Sektornummer}
          End;
  DT144 : Begin
            RegCH:=079;  {Grte Spurnummer}
            RegCL:=018;  {Grte Sektornummer}
          End;
  DT720 : Begin
            RegCH:=079;  {Grte Spurnummer}
            RegCL:=009;  {Grte Sektornummer}
          End;
  DT12  : Begin
            RegCH:=079;  {Grte Spurnummer}
            RegCL:=015;  {Grte Sektornummer}
          End;
  DT360 : Begin
            RegCH:=039;  {Grte Spurnummer}
            RegCL:=009;  {Grte Sektornummer}
          End;
  DT320 : Begin
            RegCH:=039;  {Grte Spurnummer}
            RegCL:=008;  {Grte Sektornummer}
          End;
  End;
  RegAH:=$18;     {Diskettenformat festlegen}
  RegDH:=000;     {Diskettenseite}
  RegDL:=LWB-001; {Laufwerksnummer}
  ASM
    Mov AH,RegAH
    Mov CH,RegCH
    Mov CL,RegCL
    Mov DH,RegDH
    Mov DL,RegDL
    Int $13
    PushF
    Pop RegFL
  End;
  If RegFL And FCarry=001 Then HelpReset;

End;




Procedure SWCAdjustMem;
Begin

  Repeat
    PGXLoad('ADJSTMEM','ONELINEG',
    PRGPATH+'\7WCADJM.DAT','',000,001);
    If Not BooleanErr Then
    Begin
      MoveTXTToScreen('ADJSTMEM',002,001,
      'Geben Sie eine ganze Zahl zwischen 20 und 64 ein, ...');
      MoveTXTToScreen('ADJSTMEM',006,005,
      'drcken Sie dann <ENTER>, oder <ESC> fr Exit ...');
      MoveColToScreen('ADJSTMEM',002,005,055,078);
      PGXEdit('ADJSTMEM','ONELINEG',
      PRGPATH+'\7WCADJM.DAT','',009,007,BT,000,BT,BT);
    End;
  Until SWCDataKBGet;

End;




Procedure SWCAdjustments;
Var
  Char1 : Char;
  WX    : Word;
  WY    : Word;

Begin

  Char1:='F';
  ScreenParams(BT);
  SetGround('7WCOPY',BT);
  Repeat
    OptionsR(000,000,
    'Men Einstellungen',
    'An~zahl Lese-/ Schreibversuche'+
    'Ausgabepfad ~festlegen'+
    '~Diskette formatieren'+
    'E~xit',Char1,BT);
    If Not BooleanEx Then
    Begin
      Char1:=Char0;
      If Char0='A' Then
      SWCAdjustMem
      Else
      If Char0='Z' Then
      SWCAdjustTrys
      Else
      If Char0='F' Then
      SWCAdjustOPath
      Else
      If Char0='D' Then
      SWCDiskFormat
      Else
      If Char0='S' Then
      SWCAdjustSeg;
      WaitClr;
    End;
  Until BooleanEx;
  ScreenParams(BF);

End;




Procedure SWCAdjustOPath;
Var
  BErr  : Bool;
  DH0   : Hand;
  DTyp0 : DTyp;
  LW    : ST02;
  Stri0 : ST80;

Procedure HelpShowPath;
Begin
  PGXLoad('SHOWPATH','ONELINEG',
  PRGPATH+'\7WCOUTP.DAT','',000,001);
  If Not BooleanErr Then
  Begin
    MoveTXTToScreen('SHOWPATH',002,001,
    BuendigL2(053,'Geben Sie einen Pfad zu diesem Laufwerk ein,'));
    MoveTXTToScreen('SHOWPATH',006,005,
    'drcken Sie dann <ENTER>, oder <ESC> fr Exit ...');
    MoveColToScreen('SHOWPATH',002,005,055,078);
    PGXEdit('SHOWPATH','ONELINEG',
    PRGPATH+'\7WCOUTP.DAT','',009,007,BT,000,BT,BT);
    If Boolean13 Then
    Begin
      Stri0:=EditorField;
      If Not ChkPath(Stri0) Then
      Begin
        OptionsR(000,000,
        'Der Pfad '+CutString(Stri0,050)+' existiert '+
        'nicht. Soll ich ihn erstellen ?',
        '~Ja~Nein','J',BT);
        If Char0='J' Then
        MakePath(Stri0);
      End;
    End;
  End
  Else
  ErrorOut('Fehler beim Laden von 7WCOUTP.DAT',000,'',#000);
End;

Begin

  BErr:=BT;
  PGXLoad('GETPATH','ONELINEG',
  PRGPATH+'\7WCOUTP.DAT','',000,001);
  If Not BooleanErr Then
  Begin
    If GetFieldStr('GETPATH',000,000)='' Then
    Begin
      PGXFree('GETPATH');
      OptionsR(000,000,
      'Mchten Sie den Ausgabepfad auf eine Disk'+
      'ette oder auf eine Festplatte bzw. auf ei'+
      'n Netzlaufwerk oder ein anderes Laufwerk '+
      'festlegen ?',
      '~Diskette'+
      '~Anderes Laufwerk'+
      'E~xit','A',BT);
      If Not BooleanEx Then
      Begin
        If Char0='D' Then
        LW:=DirGetFDisk('',DTyp0)
        Else
        If Char0='A' Then
        LW:=DirGetHDisk('');
        If LW<>'' Then
        If ChkDrvOk(LW) Then
        Begin
          OptionsR(000,000,
          'Ich zeige das Laufwerk '+LW+' mit den '+
          'Verzeichnissen. Um eine Ebene hher zu '+
          'gelangen, gehen Sie auf die zwei Punkte und '+
          'drcken ENTER. Um eine Ebene tiefer zu kom'+
          'men, gehen Sie auf das Verzeichnis und drck'+
          'en ENTER. Whlen Sie einen Pfad mit'+
          ' STRG + ENTER.',
          '~WeiterE~xit','W',BT);
          If Not BooleanEx Then
          Begin
            DH0:=255;
            Dir(DH0,LW+'\*.*',DIRZURUECK,063,000,BT,BF,BT);
            If Not BooleanErr Then
            Begin
              If Boolean13C Then
              Begin
                PGXLoad('GETPATH','ONELINEG',
                PRGPATH+'\7WCOUTP.DAT','',000,001);
                If Not BooleanErr Then
                Begin
                  FillField('GETPATH',000,DIRZURUECK);
                  SaveRec('GETPATH',BT);
                  PGXFree('GETPATH');
                  HelpShowPath;
                End
                Else
                ErrorOut('Fehler beim Laden von 7WCOUTP.DAT',000,'',#000);
              End;
            End
            Else
            Begin
              Ok('Das Laufwerk '+LW+' enthlt keine '+
              'Unterverzeichnisse oder Dateien.');
              PGXLoad('GETPATH','ONELINEG',
              PRGPATH+'\7WCOUTP.DAT','',000,001);
              If Not BooleanErr Then
              Begin
                FillField('GETPATH',000,LW);
                SaveRec('GETPATH',BT);
                PGXFree('GETPATH');
                HelpShowPath;
              End
              Else
              ErrorOut('Fehler beim Laden von 7WCOUTP.DAT',000,'',#000);
            End;
          End;
        End
        Else
        ErrorOut('Das Laufwerk '+LW+' ist nicht bereit',000,'',#000);
      End;
    End
    Else
    Begin
      PGXFree('GETPATH');
      HelpShowPath;
    End;
  End
  Else
  ErrorOut('Fehler beim Laden von 7WCOUTP.DAT',000,'',#000);
  BooleanErr:=BErr;

End;




Procedure SWCAdjustSeg;
Var
  Stri0 : ST10;
  Word0 : Word;

Begin

  Repeat
    PGXLoad('ADJSTSEG','ONELINEG',
    PRGPATH+'\7WCADJSG.DAT','',000,001);
    If Not BooleanErr Then
    Begin
      Word0:=GetFieldWord('ADJSTSEG',000);
      Stri0:='$'+GetHexToStr(Hi(Word0))+GetHexToStr(Lo(Word0));
      FillField('ADJSTSEG',000,Stri0);
      MoveTXTToScreen('ADJSTSEG',002,001,
      'Geben Sie ein Segmentlimit (Bitmaske, z.B. $8000) ein, ...');
      MoveTXTToScreen('ADJSTSEG',006,005,
      'drcken Sie dann <ENTER>, oder <ESC> fr Exit ...');
      MoveColToScreen('ADJSTSEG',002,005,055,078);
      PGXEdit('ADJSTSEG','ONELINEG',
      PRGPATH+'\7WCADJSG.DAT','',009,007,BT,000,BT,BT);
    End;
  Until SWCSegLimitGet<>$0000;

End;




Procedure SWCAdjustTrys;
Begin

  PGXLoad('ADJSTTRY','ONELINEG',
  PRGPATH+'\7WCADJT.DAT','',000,001);
  If Not BooleanErr Then
  Begin
    MoveTXTToScreen('ADJSTTRY',002,001,
    'Geben Sie eine ganze Zahl zw. 1 und 255 ein (z.B. 3),');
    MoveTXTToScreen('ADJSTTRY',006,005,
    'drcken Sie dann <ENTER>, oder <ESC> fr Exit ...');
    MoveColToScreen('ADJSTTRY',002,005,055,078);
    PGXEdit('ADJSTTRY','ONELINEG',
    PRGPATH+'\7WCADJT.DAT','',009,007,BT,000,BT,BT);
    SWCMaxTrysGet;
  End;

End;




Function  SWCDataKBGet: Bool;
Var
  Error : Word;
  Limit : Word;
  Word0 : Word;
  Word1 : Word;

Function  HelpGetSegAdress: Word;
Const
  Pass  : IntL=000;
Var
  Stri0 : ST10;
  TmpSg : Word;
  TmpS2 : Word;
Begin
  Inc(Pass);
  Str(Pass,Stri0);
  HelpGetSegAdress:=$0000;
  TmpSg:=GetBuf(016,Error,Word1);
  MemErrorOut('HelpGetSegAdress (Get TmpSg #1 Pass '+Stri0+')',Error,000);
  If TmpSg And $FFFF+001<Limit Then
  Begin
    HelpGetSegAdress:=HelpGetSegAdress;
    FreeBuf(TmpSg,Error);
    MemErrorOut('HelpGetSegAdress (Free TmpSg #1 Pass '+Stri0+')',Error,000);
  End
  Else
  Begin
    TmpS2:=GetBuf(DataKB*1024,Error,Word1);
    MemErrorOut('HelpGetSegAdress (Get TmpS2 Pass '+Stri0+')',Error,000);
    If TmpS2 And $FFFF<Limit Then
    Begin
      FreeBuf(TmpS2,Error);
      MemErrorOut('HelpGetSegAdress (Free TmpS2 Pass '+Stri0+')',Error,000);
      HelpGetSegAdress:=HelpGetSegAdress;
      FreeBuf(TmpSg,Error);
      MemErrorOut('HelpGetSegAdress (Free TmpSg #2 Pass '+Stri0+')',Error,000);
    End
    Else
    Begin
      HelpGetSegAdress:=TmpS2;
      FreeBuf(TmpSg,Error);
      MemErrorOut('HelpGetSegAdress (Free TmpSg #3 Pass '+Stri0+')',Error,000);
    End;
  End;
  Dec(Pass);
End;

Begin

  SWCDataKBGet:=BT;
  DataKB:=SizeOf(DArray) Div 1024;
  DataS:=Seg(DArray);
  DataO:=Ofs(DArray);
  Exit;
  DataKB:=010;
  SWCDataKBGet:=BF;
  Limit:=SWCSegLimitGet;
  PGXLoad('GETDKB','ONELINEG',
  PRGPATH+'\7WCADJM.DAT','',000,001);
  If Not BooleanErr Then
  Begin
    DataKB:=GetFieldWord('GETDKB',000);
    If (DataKB<010) Or (GetFieldStr('GETDKB',000,000)='') Then
    Begin
      DataKB:=010;
      FillField('GETDKB',000,'10');
      SaveRec('GETDKB',BT);
    End;
    If DataS<>000 Then
    Begin
      FreeBuf(DataS,Word0);
      MemErrorOut('SWCDataKBGet (Free DataS)',Word0,000);
    End;
    DataS:=HelpGetSegAdress;
    PGXFree('GETDKB');
    SWCDataKBGet:=BT;
  End
  Else
  ErrorOut('Fehler beim Laden von 7WCADJM.DAT',000,'',#000);

End;




Procedure SWCDataSFree;
Var
  Word0 : Word;
  Word1 : Word;

Begin

  If DataS<>000 Then
  Begin
    FreeBuf(DataS,Word0);
    MemErrorOut('DataS (Free)',Word0,000);
    DataS:=000;
  End
  Else
  ErrorOut('DataS war unbenutzt',000,'',#000);

End;




Procedure SWCDiskFormat;
Const
  LLine : IntL=000;

Var
  BErr  : Bool;
  BPSec : Word;
  BStart: Bool;
  BStop : Bool;
  BufS  : Word;
  Byte0 : Byte;
  CntBS : Word;
  CntSc : Byte;
  DSide : Byte;
  DTyp0 : DTyp;
  DTyp1 : DTyp;
  Long0 : IntL;
  Long1 : IntL;
  Long2 : IntL;
  LongG : IntL;
  LongP : IntL;
  LongS : IntL;
  LongT : IntL;
  LW    : ST02;
  LWB   : Byte;
  NSec  : Byte;
  ODDPT : Poin;
  SHWB0 : Bool;
  SHWH0 : Hand;
  Stri0 : ST80;
  Track : Byte;
  Word0 : Word;
  Word1 : Word;

Procedure HelpSetFormat(MaxTrack,MaxSec: Byte);     ForWard;

Procedure HelpCheckBuffer(DSide,Track,Sector: Byte;Offs: Word);
Var
  Long0 : IntL;
  StriD : ST80;
  StriO : ST80;
  StriS : ST80;
  StriT : ST80;
Begin
  Str(DSide,StriD);
  Str(Track:002,StriT);
  Str(Sector:002,StriS);
  Str(Offs:005,StriO);
  TESTSTR:='Offset: '+StriO+' DSide: '+StriD+' Track: '+StriT+' Sector: '+StriS;
  Test(TESTSTR,BF,000);
  TESTSTR:='===========================================';
  Test(TESTSTR,BF,001);
  For Long0:=000 To LongS-001 Do
  Begin
    Str(Offs+Long0*004:005,StriO);
    Str(Mem[DataS:DataO+Offs+Long0*004+000]:002,StriT);
    Str(Mem[DataS:DataO+Offs+Long0*004+001]:001,StriD);
    Str(Mem[DataS:DataO+Offs+Long0*004+002]:002,StriS);
    Str(Mem[DataS:DataO+Offs+Long0*004+003]:002,Stri0);
    TESTSTR:='Offset: '+StriO+' DSide: '+StriD+' Track: '+StriT+' Sector: '+StriS+' B.p.S.: '+Stri0;
    Test(TESTSTR,BF,002+Long0);
  End;
  RegFL:=000;
  Delay(1000);
End;

Function  HelpCheckChanged: Bool;
Begin
  RegDL:=LWB-001;
  HelpCheckChanged:=BF;
  ASM
    Mov AH,$15
    Mov DL,RegDL
    Int $13
    PushF
    Pop RegFL
    Mov RegAH,AH
  End;
  If RegFL And FCarry=000 Then
  If RegAH=002 Then
  Begin
    RegDL:=LWB-001;
    ASM
      Mov AH,$16
      Mov DL,RegDL
      Int $13
      Mov RegAH,AH
    End;
    HelpCheckChanged:=RegAH=006;
  End;
End;

Procedure HelpGetFormatParameter(DTyp0: DTyp;Var LDTyp0: LDTp);
Begin
  Case DTyp0 Of
  DT288 : LDTyp0:=LOG288;
  DT144 : LDTyp0:=LOG144;
  DT12  : LDTyp0:=LOG12;
  DT720 : LDTyp0:=LOG720;
  DT360 : LDTyp0:=LOG360;
  DT320 : LDTyp0:=LOG320;
  End;
End;

Procedure HelpLogicalFormat;
Var
  AktSector      : Byte;
  AktSide        : Byte;
  AktTrack       : Byte;
  Anzahl         : IntM;    { Anzahl noch zu schreibende Sektoren }
  ByteD          : Byte;
  ByteS          : Byte;
  ByteT          : Byte;
  I              : Byte;                           { Schleifenzhler }
  LData          : LDTp;
  MaxDS          : Word;
  MaxSe          : Word;
  MaxTr          : Word;
Begin
  BStart:=BT;
  CntSc:=001;
  Case CntBS Of
  003 : CntBS:=1024;
  002 : CntBS:=0512;
  001 : CntBS:=0256;
  000 : CntBS:=0128;
  End;
  HelpGetFormatParameter(DTyp1,LData);
  HelpGetParameters(Dtyp1,ByteD,ByteT,ByteS);
  MaxDS:=ByteD;
  MaxSe:=ByteS;
  MaxTr:=ByteT;
  Anzahl:=LData.FAT*002+(LData.Rootsize*032 Div CntBS)+001;
  FillChar(Mem[DataS:DataO+000],MaxSe*CntBS,$00); {Buf. leeren}
  {-- Bootsektor: fester Teil -----------------------------------------}
  Move(BootMaske,Mem[DataS:DataO+000],102);      { Maske Bootsektor kopieren }
  Move(BootMes[001],Mem[DataS:DataO+102],Ord(BootMes[000]));
  Mem[DataS:DataO+CntBS-002]:=$55;      { Ende-Kennzeichen des Bootsektors }
  Mem[DataS:DataO+CntBS-001]:=$AA;
  {-- Bootsektor: variabler Teil---------------------------------------}
  Mem[DataS:DataO+$0B]:=Lo(CntBS);
  Mem[DataS:DataO+$0C]:=Hi(CntBS);
  Mem[DataS:DataO+$0D]:=LData.Cluster;               { Clustergre }
  MemW[DataS:DataO+$0E]:=$01;                        { Anzahl reserv. Sektoren }
  Mem[DataS:DataO+$10]:=$02;                         { Anzahl FATs }
  MemW[DataS:DataO+$11]:=Word(LData.RootSize);       { Anzahl Eintrge im Hauptv. }
  Mem[DataS:DataO+$13]:=Lo((MaxDS+001)*MaxTr*MaxSe); { Gesamtanzahl Sektoren }
  Mem[DataS:DataO+$14]:=Hi((MaxDS+001)*MaxTr*MaxSe); { auf der Diskette      }
  Mem[DataS:DataO+$15]:=LData.Media;                 { Media-Deskriptor }
  MemW[DataS:DataO+$16]:=Word(LData.FAT);            { Gre der FAT }
  MemW[DataS:DataO+$18]:=MaxSe;                      { Sektoren pro Spur }
  MemW[DataS:DataO+$1A]:=MaxDS+001;                  { Anzahl der Seiten }
  MemW[DataS:DataO+$1C]:=$0000;
  {-- FAT und FAT-Kopie anlegen (Inhalt 00)----------------------------}
  Mem[DataS:DataO+CntBS+000]:=LData.Media;   { 1. FAT anlegen }
  Mem[DataS:DataO+CntBS+001]:=$FF;
  Mem[DataS:DataO+CntBS+002]:=$FF;
  Mem[DataS:DataO+(LData.FAT+001)*CntBS+000]:=LData.Media; { 2. FAT anlegen }
  Mem[DataS:DataO+(LData.FAT+001)*CntBS+001]:=$FF;
  Mem[DataS:DataO+(LData.FAT+001)*CntBS+002]:=$FF;
  {-- Boot-Sektor und FAT schreiben -----------------------------------}
  Byte0:=HelpReadWriteDisk($03,
  LWB,000,DataS,000,001,MaxSe,DataO+$0000,MaxSe,CntBS,BStop,BStart);
  {-- kein Fehler, Rootverzeichnis schreiben --------------------------}
  FillChar(Mem[DataS:DataO+$0000],CntBS,000); { Leerer Sektor }
  AktSector:=MaxSe;      { Erste Spur komplett geschrieben }
  AktTrack:=000;                                   { Aktuelle Spur }
  AktSide:=000;                                   { Aktuelle Seite }
  {-- Anzahl der verbleibenden Sektoren ermitteln und schreiben ---}
  Anzahl:=LData.FAT*002+(LData.Rootsize*032 Div CntBS)+001-MaxSe;
  I:=001;
  BStart:=BT;
  Repeat
    Inc(AktSector);                            { Nchster Sektor }
    If AktSector>MaxSe Then         { Spur zu Ende? }
    Begin
      AktSector:=001;                      { Weiter bei Sektor 1 }
      Inc(AktSide);                           { Nchste Seite? }
      If AktSide>MaxDS Then       { Schon 2. Seite? }
      Begin
        AktSide:=000;                     { Wieder auf Seite 0 }
        Inc(AktTrack);
      End;
    End;
    HelpReadWriteDisk($03,
    LWB,AktSide,DataS,AktTrack,AktSector,001,DataO+$0000,MaxSe,CntBS,BStop,BStart);
    Inc(I);
  Until (I>Anzahl) Or BStop;
End;

Procedure HelpSetFormat(MaxTrack,MaxSec: Byte);
Begin
  RegAH:=$18;
  RegCH:=MaxTrack;
  RegCL:=MaxSec;
  RegDL:=LWB-001;
  ASM
    Mov AH,RegAH
    Mov CH,RegCH
    Mov CL,RegCL
    Mov DL,RegDL
    Int $13
    PushF
    Pop RegFL
    Mov RegAH,AH
  End;
End;

Begin

  OptionsR(000,000,
  'Whlen Sie den gewnschten Diskettentyp aus der '+
  'Liste mit vordefinierten Typen und drcken <ENTER> ...',
  '~WeiterE~xit','W',BT);
  If Not BooleanEx Then
  Begin
    LSNEdit('7WCDTYP',000,000,000,000,
    PRGPATH+'\7WCDTYP.LSN','',$00000004,BF,LLine,BT,BF,BT,BT,BT,BT);
    If Boolean13 Then
    Begin
      LLine:=ALnLSN;
      OptionsR(000,000,
      'Legen Sie nun eine Diskette in eines Ihrer '+
      'Diskettenlaufwerke, whlen das entsprechend'+
      'e Laufwerk aus der Liste und drcken ENTER.',
      '~WeiterE~xit','W',BT);
      If Not BooleanEx Then
      Begin
        LW:=DirGetFDisk('',DTyp0);
        If LW<>'' Then
        Begin
          BStop:=BF;
          LWB:=Ord(LW[001])-064;
          DTyp1:=DTyp(006-LLine);
          ChkDisketteOk(LWB,DTyp0,BStop);
          If BStop Then
          Begin
            OptionsR(000,000,
            'Das Format der Diskette in Laufwerk '+LW+
            ' konnte nicht ermittelt werden. Soll ich'+
            ' dennoch versuchen, zu formatieren ?',
            '~Ja~Nein','J',BT);
            If Char0='J' Then
            Begin
              BStop:=BF;
              DTyp0:=DTyp1;
            End;
          End;
          If Not BStop Then
          Begin
            BErr:=BF;
            If DTyp0<>DTyp1 Then
            Begin
              BErr:=BT;
              ErrorOut('Ausgewhlter Diskettentyp '+
              HelpGetDTypAsString(DTyp1)+' ist nicht '+
              'mit Zieldiskettentyp '+
              HelpGetDTypAsString(DTyp0)+' kompatibel. '+
              'Soll ich dennoch mit dem Formatieren fortfahren ?',000,
              '~Ja~Nein','J');
              If Char0='J' Then
              BErr:=BF;
            End;
            If Not BErr Then
            Begin
              OptionsR(000,000,
              'Achtung! Alle Daten auf der Diskette '+
              'in Laufwerk '+LW+' werden gelscht! S'+
              'oll ich fortfahren ?',
              '~Ja~Nein','N',BT);
              If Char0='J' Then
              Begin
                CntBS:=GetListLong('7WCDTYP',LLine,003);
                LongP:=GetListLong('7WCDTYP',LLine,000);
                LongT:=GetListLong('7WCDTYP',LLine,001);
                LongS:=GetListLong('7WCDTYP',LLine,002);
                CntSc:=LongS;
                LongG:=LongP*LongT*LongS*004 Div 1024;
                If LongG*1024<LongP*LongT*LongS*004 Then
                Inc(LongG);
                If LongG>DataKB Then
                Begin
                  Str(LongG,Stri0);
                  ErrorOut('Sie haben zu wenig Arbeitsspeicher '+
                  'reserviert. Sie brauchen, um diese Funktion '+
                  'mit diesen Einstellungen durchzufhren, '+Stri0+
                  ' KB Speicher. Soll ich soviel fr Sie reservieren ?',
                  000,'~Ja~Nein','J');
                  If Char0='J' Then
                  Begin
                    PGXLoad('ADJSTMEM','ONELINEG',
                    PRGPATH+'\7WCADJM.DAT','',000,001);
                    If Not BooleanErr Then
                    Begin
                      FillField('ADJSTMEM',000,Stri0);
                      SaveRec('ADJSTMEM',BT);
                      PGXFree('ADJSTMEM');
                      SWCDataKBGet;
                    End
                    Else
                    ErrorOut('Fehler beim Laden von '+
                    '7WCADJM.DAT',000,'',#000);
                  End;
                End;
                If LongG<=DataKB*1024 Then
                Begin
                  BPSec:=CntBS;
                  Case CntBS Of
                  1024 : CntBS:=003;
                  0512 : CntBS:=002;
                  0256 : CntBS:=001;
                  0128 : CntBS:=000;
                  End;
                  For Long0:=000 To LongT-001 Do
                  For Long1:=000 To LongP-001 Do
                  For Long2:=001 To LongS Do
                  Begin
                    Mem[DataS:DataO+(Long0*002+Long1)*072+(Long2-001)*004+000]:=Long0;
                    Mem[DataS:DataO+(Long0*002+Long1)*072+(Long2-001)*004+001]:=Long1;
                    Mem[DataS:DataO+(Long0*002+Long1)*072+(Long2-001)*004+002]:=Long2;
                    Mem[DataS:DataO+(Long0*002+Long1)*072+(Long2-001)*004+003]:=CntBS;
                  End;
                  BStop:=BT;
                  HelpGetSetIntVecsOn(DTyp0);
                  Repeat
                    HelpSetFormat(LongT-001,CntSc);
                    If (RegFL And FCarry=000) Or Not BStop Then
                    Begin
                      TempI;
                      BStop:=BF;
                      SHWB0:=BT;
                      BStart:=BT;
                      For Track:=000 To LongT-001 Do
                      If Not BStop Then
                      Begin
                        ShowP('Formatiere Laufwerk '+LW,
                        SHWB0,SHWH0,030,025,012,Track,LongT-001,BF);
                        For DSide:=000 To LongP-001 Do
                        If Not BStop Then
                        Begin
                          NSec:=001;
                          Repeat
                            Byte0:=HelpReadWriteDisk($05,
                            LWB,DSide,DataS,Track,NSec,CntSc,
                            DataO+(Track*002+DSide)*(019-NSec)*004,
                            CntSc-NSec+001,BPSec,BStop,BStart);
                            Inc(NSec,Byte0);
                          Until (NSec>CntSc) Or BStop;
                        End;
                      End;
                      If Not BStop Then
                      Begin
                        TempO;
                        TempI;
                        OptionsR(000,000,
                        'Bootsektor, Root und FAT anlegen ?',
                        '~Ja~Nein','J',BT);
                        If Char0='J' Then
                        HelpLogicalFormat;
                      End;
                      TempO;
                    End
                    Else
                    Begin
                      BErr:=BT;
                      HelpErrorOut(RegAH,BStop);
                    End;
                  Until BStop Or Not BErr;
                  HelpGetSetIntVecsOff;
                End;
              End;
            End;
          End;
        End;
      End;
      If LSNTest('7WCDTYP') Then
      LSNFree('7WCDTYP');
    End;
  End;

End;




Procedure SWCDiskMake;
Var
  BErr  : Bool;
  BOffs : Word;
  BOk   : Bool;
  BPSec : Word;
  BStart: Bool;
  BStop : Bool;
  Byte0 : Byte;
  Byte1 : Byte;
  CntSec: Byte;
  DSide : Byte;
  DTyp0 : DTyp;
  LW    : ST02;
  LWB   : Byte;
  MaxDS : Byte;
  MaxSe : Byte;
  MaxTr : Byte;
  MTyp0 : DTyp;
  NSec  : Byte;
  SHWB0 : Bool;
  SHWH0 : Hand;
  Stri0 : STFF;
  Stri1 : STFF;
  Stri2 : STFF;
  Stri3 : STFF;
  Track : Byte;
  Try   : Byte;
  Word0 : Word;
  Word1 : Word;
  XMSLW : IntL;

Function  HelpCheckChanged: Bool;
Begin
  RegDL:=LWB-001;
  HelpCheckChanged:=BF;
  ASM
    Mov AH,$15
    Mov DL,RegDL
    Int $13
    PushF
    Pop RegFL
    Mov RegAH,AH
  End;
  If RegFL And FCarry=000 Then
  If RegAH=002 Then
  Begin
    RegDL:=LWB-001;
    ASM
      Mov AH,$16
      Mov DL,RegDL
      Int $13
      Mov RegAH,AH
    End;
    HelpCheckChanged:=RegAH=006;
  End;
End;

Function  HelpGetBytesPerSector: Word;
Begin
  HelpGetBytesPerSector:=000;
  RegDL:=LWB-001;
  ASM
    Mov AH,$08
    Mov DL,RegDL
    Int $13
    PushF
    Pop RegFL
    Mov RegAX,AX
    Mov RegBX,BX
    Mov RegCX,CX
    Mov RegDX,DX
    Mov RegES,ES
    Mov RegDI,DI
  End;
  If RegFL And FCarry=000 Then
  Begin
    Byte0:=Mem[RegES:RegDI+003];
    Case Byte0 Of
    000 : HelpGetBytesPerSector:=128;
    001 : HelpGetBytesPerSector:=256;
    002 : HelpGetBytesPerSector:=512;
    003 : HelpGetBytesPerSector:=1024;
    End;
  End
  Else
  Begin
    BStop:=BT;
    ErrorOut('Fehler beim Erfragen der Diskettenparameter',000,'',#000);
  End;
End;

Function  HelpImageGetBytesPerSec: Byte;
Begin
  HelpImageGetBytesPerSec:=000;
  With XMSMOVSTRUC Do
  Begin
    XMSLen:=256;
    HandleT:=000;
    Ptr0:=Ptr(DataS,DataO+$0000);
    Move(Ptr0,OffsT,004);
    HandleS:=XMSHANDLE;
    OffsS:=XMSOFFSETS[XMSGHand2(XMSH0)];
    XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
    Move(Mem[DataS:DataO+0],Stri0,256);
    Byte0:=Pos('BytesPerSector=',Stri0);
    If Byte0>000 Then
    Begin
      Val(Copy(Stri0,Byte0+015,005),Word0,ValCode);
      HelpImageGetBytesPerSec:=Word0;
    End;
  End;
End;

Function  HelpImageGetDiskType: DTyp;
Var
  DTyp0  : DTyp;
Begin
  HelpImageGetDiskType:=DTNone;
  With XMSMOVSTRUC Do
  Begin
    XMSLen:=256;
    HandleT:=000;
    Ptr0:=Ptr(DataS,DataO+$0000);
    Move(Ptr0,OffsT,004);
    HandleS:=XMSHANDLE;
    OffsS:=XMSOFFSETS[XMSGHand2(XMSH0)];
    XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
    Move(Mem[DataS:DataO+0],Stri0,256);
    Byte0:=Pos('Mediatype=',Stri0);
    If Byte0>000 Then
    Stri0:=BuendigLR(Copy(Stri0,Byte0+010,005));
    If Stri0='DT288' Then DTyp0:=DT288
    Else
    If Stri0='DT144' Then DTyp0:=DT144
    Else
    If Stri0='DT720' Then DTyp0:=DT720
    Else
    If Stri0='DT12'  Then DTyp0:=DT12
    Else
    If Stri0='DT320' Then DTyp0:=DT320
    Else
    If Stri0='DT360' Then DTyp0:=DT360;
    HelpImageGetDiskType:=DTyp0;
  End;
End;

Function  HelpImageGetVersion: ST16;
Begin
  With XMSMOVSTRUC Do
  Begin
    XMSLen:=016;
    HandleT:=000;
    Ptr0:=Ptr(DataS,DataO+$0000);
    Move(Ptr0,OffsT,004);
    HandleS:=XMSHANDLE;
    OffsS:=XMSOFFSETS[XMSGHand2(XMSH0)];
    XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
    Stri0[000]:=#016;
    Move(Mem[DataS:DataO+0],Stri0[001],016);
    HelpImageGetVersion:=Copy(Stri0,001,016);
  End;
End;

Procedure HelpReadXMS1(Var DSide,Track,NSec: Byte);
Begin
  With XMSMOVSTRUC Do
  Begin
    XMSLen:=016;
    HandleT:=000;
    HandleS:=XMSHANDLE;
    Ptr0:=Ptr(DataS,DataO+$0000);
    Move(Ptr0,OffsT,004);
    OffsS:=XMSOFFSETS[XMSGHand2(XMSH0)]+XMSLW;
    XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
    Stri0[000]:=#004;
    Stri1[000]:=#004;
    Stri2[000]:=#004;
    Stri3[000]:=#004;
    Move(Mem[DataS:DataO+$00],Stri0[001],004);
    Move(Mem[DataS:DataO+$04],Stri1[001],004);
    Move(Mem[DataS:DataO+$08],Stri2[001],004);
    Move(Mem[DataS:DataO+$0C],Stri3[001],004);
    Val(Stri0,DSide,ValCode);
    Val(Stri1,Track,ValCode);
    Val(Stri2,NSec,ValCode);
    Val(Stri3,BPSec,ValCode);
    Inc(XMSLW,016);
  End;
End;

Procedure HelpReadXMS2(Var BOfs: Word);
Begin
  With XMSMOVSTRUC Do
  Begin
    HandleT:=000;
    HandleS:=XMSHANDLE;
    XMSLen:=BPSec;
    Ptr0:=Ptr(DataS,DataO+BOfs);
    Move(Ptr0,OffsT,004);
    OffsS:=XMSOFFSETS[XMSGHand2(XMSH0)]+XMSLW;
    XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
    Inc(XMSLW,BPSec);
    Inc(BOfs,BPSec);
  End;
End;

Procedure HelpReset(BDo: Bool);
Begin
  RegDL:=LWB-001;
  ASM
    Mov  AH,$00
    Mov  DL,RegDL
    Int  $13
    PushF
    Pop  RegFL
  End;
  If BDo Then
  If RegFL And FCarry=000 Then
  BStop:=BF
  Else
  BStop:=BT;
End;

Begin

  BErr:=BT;
  If XMSLA>000 Then
  Begin
    Try:=000;
    BStop:=BF;
    LW:=DirGetFDisk('',DTyp0);
    If LW<>'' Then
    Repeat
      LWB:=Ord(LW[001])-064;
      If ChkDisketteOk(LWB,DTyp0,BStop) Then
      Begin
        If HelpCheckChanged Then
        HelpReset(BT);
        Try:=000;
        Repeat
          BPSec:=HelpGetBytesPerSector;
          If (BPSec<>000) And (BPSec<>HelpImageGetBytesPerSec) Then
          Begin
            TempI;
            HelpReset(BT);
            If Not BStop Then
            Begin
              BOk:=BT;
              HelpGetParameters(DTyp0,MaxDS,MaxTr,MaxSe);
              If DataKB*1024<MaxSe*BPSec+016 Then
              Begin
                Str((MaxSe*BPSec+016) Div 1024+001,Stri0);
                ErrorOut('Sie haben zu wenig Arbeitsspeicher '+
                'reserviert. Sie brauchen, um diese Funktion '+
                'durchzufhren, '+Stri0+' KB Speicher. Soll i'+
                'ch soviel fr Sie reservieren ?',
                000,'~Ja~Nein','J');
                If Char0='J' Then
                Begin
                  PGXLoad('ADJSTMEM','ONELINEG',
                  PRGPATH+'\7WCADJM.DAT','',000,001);
                  If Not BooleanErr Then
                  Begin
                    FillField('ADJSTMEM',000,Stri0);
                    SaveRec('ADJSTMEM',BT);
                    PGXFree('ADJSTMEM');
                    SWCDataKBGet;
                  End
                  Else
                  ErrorOut('Fehler beim Laden von '+
                  '7WCADJM.DAT',000,'',#000);
                End
                Else
                BOk:=BF;
              End
              Else
              If DTyp0<>HelpImageGetDiskType Then
              Begin
                ErrorOut('Die Disktypen sind ungleich. '+
                'Kopieren ist nicht mglich',000,'',#000);
                BOk:=BF;
              End;
              If ((DTyp0=HelpImageGetDiskType)
              And (DataKB*1024>=MaxSe*BPSec+016)) Or BOk Then
              Begin
                TempO;
                TempI;
                OptionsR(000,000,
                'Achtung! Alle Daten auf der Diskette '+
                'in Laufwerk '+LW+' werden berschrieb'+
                'en! Soll ich fortfahren ?',
                '~Ja~Nein','N',BT);
                If Char0='J' Then
                Begin
                  SHWB0:=BT;
                  BStart:=BT;
                  XMSLW:=256;
                  DTyp0:=HelpImageGetDiskType;
                  HelpGetSetIntVecsOn(DTyp0);
                  HelpGetParameters(DTyp0,MaxDS,MaxTr,MaxSe);
                  HelpSetFormat(DTyp0,LWB);
                  Repeat
                    ShowP('Schreibe Diskettendaten ...',
                    SHWB0,SHWH0,034,023,012,XMSLW,XMSLA,BF);
                    BOffs:=$0010;
                    Repeat
                      HelpReadXMS1(DSide,Track,NSec);
                      HelpReadXMS2(BOffs);
                    Until NSec=MaxSe;
                    Try:=000;
                    NSec:=001;
                    CntSec:=MaxSe;
                    Repeat
                      Byte0:=HelpReadWriteDisk($03,LWB,
                      DSide,DataS,Track,NSec,CntSec,
                      DataO+(NSec-001)*MaxSe*BPSec+016,MaxSe,BPSec,BStop,BStart);
                      If Byte0=000 Then Inc(Try)
                      Else
                      Begin
                        Inc(NSec,Byte0);
                        Dec(CntSec,Byte0);
                      End;
                    Until (NSec>MaxSe) Or BStop Or (Try=MaxTrys);
                  Until (XMSLW=XMSLA) Or BStop;
                  If Not BStop Then BErr:=BF;
                  HelpGetSetIntVecsOff;
                  ShowPClr(SHWH0);
                End
                Else
                BStop:=BT;
              End
              Else
              Begin
                TempO;
                TempI;
                BStop:=BT;
                ErrorOut('Diskettentypen sind nicht kompatibel',000,'',#000);
              End;
            End;
            TempO;
          End
          Else
          Begin
            BStop:=BT;
            ErrorOut('Unterschiedliche Anzahl '+
            'von Bytes pro Sektor',000,'',#000);
          End;
        Until (Try>=MaxTrys) Or (Not BErr) Or BStop;
        HelpReset(BF);
      End
      Else
      Begin
        Inc(Try);
        HelpReset(BF);
      End;
    Until (Try>=MaxTrys) Or (Not BErr) Or BStop;
  End
  Else
  ErrorOut('Es befindet sich kein Diskettenimage '+
  'im Speicher. Bitte erst laden oder erstellen',000,'',#000);
  BooleanErr:=BErr;

End;




Procedure SWCDiskReadIn;
Var
  BErr  : Bool;
  BPSec : Word;
  BStop : Bool;
  BStart: Bool;
  Byte0 : Byte;
  CntSec: Byte;
  DSide : Byte;
  DTyp0 : DTyp;
  LW    : ST02;
  LWB   : Byte;
  MaxDS : Byte;
  MaxSe : Byte;
  MaxTr : Byte;
  MTyp0 : DTyp;
  NSec  : Byte;
  SHWB0 : Bool;
  SHWH0 : Hand;
  Stri0 : STFF;
  Stri1 : STFF;
  Stri2 : STFF;
  Stri3 : STFF;
  Track : Byte;
  Try   : Byte;
  Word0 : Word;
  Word1 : Word;

Procedure HelpWriteXMS;   ForWard;

Function  HelpCheckChanged: Bool;
Begin
  RegDL:=LWB-001;
  HelpCheckChanged:=BF;
  ASM
    Mov AH,$15
    Mov DL,RegDL
    Int $13
    PushF
    Pop RegFL
    Mov RegAH,AH
  End;
  If RegFL And FCarry=000 Then
  If RegAH=002 Then
  Begin
    RegDL:=LWB-001;
    ASM
      Mov AH,$16
      Mov DL,RegDL
      Int $13
      Mov RegAH,AH
    End;
    HelpCheckChanged:=RegAH=006;
  End;
End;

Function  HelpGetBytesPerSector: Word;
Begin
  HelpGetBytesPerSector:=000;
  RegDL:=LWB-001;
  ASM
    Mov AH,$08
    Mov DL,RegDL
    Int $13
    PushF
    Pop RegFL
    Mov RegAX,AX
    Mov RegBX,BX
    Mov RegCX,CX
    Mov RegDX,DX
    Mov RegES,ES
    Mov RegDI,DI
  End;
  If RegFL And FCarry=000 Then
  Begin
    Byte0:=Mem[RegES:RegDI+003];
    Case Byte0 Of
    000 : HelpGetBytesPerSector:=128;
    001 : HelpGetBytesPerSector:=256;
    002 : HelpGetBytesPerSector:=512;
    003 : HelpGetBytesPerSector:=1024;
    Else
    ErrorOut('HelpGetBytesPerSector: Unbekannte Sektorgre',000,'',#000);
    End;
  End
  Else
  Begin
    BStop:=BT;
    ErrorOut('Fehler beim Erfragen der Diskettenparameter',000,'',#000);
  End;
End;

Procedure HelpWriteHeader;
Begin
  Case DTyp0 Of
  DT288  : Stri2:='DT288';
  DT144  : Stri2:='DT144';
  DT12   : Stri2:='DT12 ';
  DT720  : Stri2:='DT720';
  DT360  : Stri2:='DT360';
  DT320  : Stri2:='DT320';
  End;
  Str(BPSec:005,Stri1);
  Stri0:=BuendigL2(255,'7WCOPY V20020620 - '+
  'BytesPerSector='+Stri1+' - '+
  'Mediatype='+Stri2+' - ');
  With XMSMOVSTRUC Do
  Begin
    XMSLen:=256;
    HandleS:=000;
    Move(Stri0,Mem[DataS:DataO+0],256);
    Ptr0:=Ptr(DataS,DataO+$0000);
    Move(Ptr0,OffsS,004);
    HandleT:=XMSHANDLE;
    OffsT:=XMSOFFSETS[XMSGHand2(XMSH0)]+XMSLA;
    XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
    Inc(XMSLA,256);
  End;
End;

Procedure HelpWriteXMS;
Procedure HelpWriteXMS2;
Begin
  With XMSMOVSTRUC Do
  Begin
    HandleS:=000;
    XMSLen:=BPSec;
    Ptr0:=Ptr(DataS,DataO+$0004+(NSec-001)*BPSec);
    Move(Ptr0,OffsS,004);
    HandleT:=XMSHANDLE;
    OffsT:=XMSOFFSETS[XMSGHand2(XMSH0)]+XMSLA;
    XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
    Inc(XMSLA,BPSec);
  End;
End;
Begin
  NSec:=001;
  Repeat
    Str(NSec:004,Stri2);
    Str(DSide:004,Stri0);
    Str(Track:004,Stri1);
    Str(BPSec:004,Stri3);
    With XMSMOVSTRUC Do
    Begin
      XMSLen:=004;
      HandleS:=000;
      Move(Stri0[001],Mem[DataS:DataO+0],004);
      Ptr0:=Ptr(DataS,DataO+$0000);
      Move(Ptr0,OffsS,004);
      HandleT:=XMSHANDLE;
      OffsT:=XMSOFFSETS[XMSGHand2(XMSH0)]+XMSLA;
      XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
      Inc(XMSLA,004);
      XMSLen:=004;
      HandleS:=000;
      Move(Stri1[001],Mem[DataS:DataO+0],004);
      Ptr0:=Ptr(DataS,DataO+$0000);
      Move(Ptr0,OffsS,004);
      HandleT:=XMSHANDLE;
      OffsT:=XMSOFFSETS[XMSGHand2(XMSH0)]+XMSLA;
      XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
      Inc(XMSLA,004);
      XMSLen:=004;
      HandleS:=000;
      Move(Stri2[001],Mem[DataS:DataO+0],004);
      Ptr0:=Ptr(DataS,DataO+$0000);
      Move(Ptr0,OffsS,004);
      HandleT:=XMSHANDLE;
      OffsT:=XMSOFFSETS[XMSGHand2(XMSH0)]+XMSLA;
      XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
      Inc(XMSLA,004);
      XMSLen:=004;
      HandleS:=000;
      Move(Stri3[001],Mem[DataS:DataO+0],004);
      Ptr0:=Ptr(DataS,DataO+$0000);
      Move(Ptr0,OffsS,004);
      HandleT:=XMSHANDLE;
      OffsT:=XMSOFFSETS[XMSGHand2(XMSH0)]+XMSLA;
      XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
      Inc(XMSLA,004);
      HelpWriteXMS2;
      Inc(NSec);
    End;
  Until NSec>MaxSe;
End;

Begin

  BErr:=BT;
  Try:=000;
  BStop:=BF;
  LW:=DirGetFDisk('',DTyp0);
  If LW<>'' Then
  Repeat
    LWB:=Ord(LW[001])-064;
    If HelpCheckChanged Then
    HelpReset(BT,LWB,BStop);
    If ChkDisketteOk(LWB,DTyp0,BStop) Then
    Begin
      If XMSLA>000 Then
      XMSFreeByHandle(XMSH0);
      XMSH0:=XMSGetHandle(LW+'.7WI',XMSMyBlock);
      XMSLA:=000;
      Try:=000;
      Repeat
        BPSec:=HelpGetBytesPerSector;
        If BPSec<>000 Then
        Begin
          TempI;
          HelpReset(BT,LWB,BStop);
          If Not BStop Then
          Begin
            HelpGetParameters(DTyp0,MaxDS,MaxTr,MaxSe);
            If DTyp0<>DTNone Then
            Begin
              If DataKB*1024<Word(MaxSe*BPSec+004) Then
              Begin
                Str((MaxSe*BPSec+004) Div 1024+001,Stri0);
                ErrorOut('Sie haben zu wenig Arbeitsspeicher '+
                'reserviert. Sie brauchen, um diese Funktion '+
                'durchzufhren, '+Stri0+' KB Speicher. Soll i'+
                'ch soviel fr Sie reservieren ?',
                000,'~Ja~Nein','J');
                If Char0='J' Then
                Begin
                  PGXLoad('ADJSTMEM','ONELINEG',
                  PRGPATH+'\7WCADJM.DAT','',000,001);
                  If Not BooleanErr Then
                  Begin
                    FillField('ADJSTMEM',000,Stri0);
                    SaveRec('ADJSTMEM',BT);
                    PGXFree('ADJSTMEM');
                    SWCDataKBGet;
                  End
                  Else
                  ErrorOut('Fehler beim Laden von '+
                  '7WCADJM.DAT',000,'',#000);
                End;
              End;
              If DataKB*1024>=Word(MaxSe*BPSec+004) Then
              Begin
                TempO;
                TempI;
                SHWB0:=BT;
                BStop:=BF;
                BStart:=BT;
                HelpWriteHeader;
                Track:=000;
                HelpGetSetIntVecsOn(DTyp0);
                HelpSetFormat(DTyp0,LWB);
                Repeat
                  ShowP('Lade Diskettendaten ...',
                  SHWB0,SHWH0,030,025,012,Track,MaxTr-001,BF);
                  DSide:=000;
                  Repeat
                    NSec:=001;
                    CntSec:=MaxSe;
                    Repeat
                      Byte0:=HelpReadWriteDisk($02,LWB,
                      DSide,DataS,Track,NSec,CntSec,
                      DataO+$0004+(NSec-001)*BPSec,MaxSe,BPSec,BStop,BStart);
                      If Byte0=000 Then
                      Begin
                        Byte0:=001;
                        FillChar(Mem[DataS:DataO+$0004+(NSec-001)*BPSec],BPSec,'X')
                      End
                      Else
                      Dec(CntSec,Byte0);
                      Inc(NSec,Byte0);
                    Until (NSec>MaxSe) Or BStop;
                    HelpWriteXMS;
                    Inc(DSide);
                  Until (DSide>MaxDS) Or BStop;
                  If Not BStop Then Inc(Track);
                Until (Track=MaxTr) Or BStop;
                If BStop Then
                ShowPClr(SHWH0);
                HelpGetSetIntVecsOff;
                If Not BStop Then
                Begin
                  TempO;
                  TempI;
                  BErr:=BF;
                End
                Else
                Begin
                  TempO;
                  TempI;
                  BErr:=BF;
                  OptionsR(000,000,
                  'Die Diskette konnte nicht ganz eingelesen '+
                  'werden. Mchten Sie die bisher eingelesene'+
                  'n Daten behalten oder verwerfen ?',
                  '~Behalten'+
                  '~Verwerfen','B',BT);
                  If Char0='V' Then
                  Begin
                    XMSLA:=000;
                    XMSFreeByHandle(XMSH0);
                  End
                  Else
                  Begin
                    SHWB0:=BT;
                    Repeat
                      ShowP('Lade Diskettendaten ...',
                      SHWB0,SHWH0,030,025,012,Track,MaxTr-001,BF);
                      Repeat
                        CntSec:=MaxSe;
                        Repeat
                          FillChar(Mem[DataS:DataO+$0004+(NSec-001)*BPSec],BPSec,#000);
                          Inc(NSec,001);
                        Until NSec>MaxSe;
                        NSec:=001;
                        HelpWriteXMS;
                        Inc(DSide);
                      Until DSide>MaxDS;
                      DSide:=000;
                      Inc(Track);
                    Until Track=MaxTr;
                    ShowPClr(SHWH0);
                  End;
                End;
              End;
            End
            Else
            Begin
              TempO;
              TempI;
              BStop:=BT;
              ErrorOut('Unbekannter Diskettentyp',000,'',#000);
            End;
          End;
          TempO;
        End
        Else
        Begin
          Inc(Try);
          HelpReset(BF,LWB,BStop);
        End;
      Until (Try>=MaxTrys) Or (Not BErr) Or BStop;
      HelpReset(BF,LWB,BStop);
    End
    Else
    Begin
      Inc(Try);
      HelpReset(BF,LWB,BStop);
    End;
  Until (Try>=MaxTrys) Or (Not BErr) Or BStop;
  BooleanErr:=BErr;

End;




Procedure SWCImageLoad;
Const
  LComm : ST80='';
  LLine : IntL=000;

Var
  BErr  : Bool;
  Byte0 : Byte;
  Cntr  : IntL;
  DH0   : Hand;
  DStr  : ST67;
  EStr  : ST04;
  FName : ST13;
  HandF : Hand;
  HandT : Hand;
  IPath : ST79;
  Long0 : IntL;
  Long1 : IntL;
  LW    : ST02;
  NStr  : ST08;
  SHWB0 : Bool;
  SHWH0 : Hand;
  Stri0 : STFF;
  Word0 : Word;
  Word1 : Word;

Function  HelpCheckChoosed: IntL;
Var
  Long0 : IntL;
  Long1 : IntL;
Procedure HelpCheckChoosedSet;
Begin
  MoveXMSToDVec(DH0,LLine);
  With DirVec[DH0] Do
  DReserv:=DReserv Or 001;
  MoveDVecToXMS(DH0,LLine);
  Long0:=001;
End;
Begin
  Long0:=000;
  For Long1:=000 To DirEA[DH0] Do
  If GetFileChoo(DH0,Long1) Then Inc(Long0);
  If Long0=000 Then
  HelpCheckChoosedSet;
  HelpCheckChoosed:=Long0;
End;

Function  HelpGetComment(FName: ST13): ST80;
Begin
  Scramble:='';
  ZIPUNZIPC:=256;
  If UnZip(IPath+'\'+FName,PRGPATH+'\7WCLOAD.TMP') Then
  Begin
    ZIPUNZIPC:=-001;
    HelpGetComment:='*** Kein Kommentar vorhanden ***';
    OFileF(HandF,PRGPATH+'\7WCLOAD.TMP',FRead,001);
    If IOResult2=000 Then
    Begin
      BlockRead(HandF,Stri0,256,CntrHROW0);
      If Pos('7WCOPY V20020620',Stri0)=001 Then
      Begin
        Byte0:=Pos('Comment=',Stri0);
        If Byte0>000 Then
        Begin
          LComm:=Copy(Stri0,Byte0+008,080);
          HelpGetComment:=Copy(Stri0,Byte0+008,080);
        End;
      End
      Else
      HelpGetComment:='';
      OFileF(HandF,'',FClose,001);
    End;
    OFileT(HandT,PRGPATH+'\7WCLOAD.TMP',FErase);
  End
  Else
  HelpGetComment:='';
  ZIPUNZIPC:=-001;
  If HelpCheckChoosed>001 Then
  Scramble:='';
End;

Begin

  BErr:=BT;
  OFileT(HandT,PRGPATH+'\7WCOUTP.DAT',FRead);
  If IOResult2=002 Then
  Begin
    OFileT(HandT,PRGPATH+'\7WCOUTP.DAT',FNew);
    If IOResult2=000 Then
    Begin
      WriteLn(HandT,PRGPATH);
      OFileT(HandT,'',FClose);
      OFileT(HandT,PRGPATH+'\7WCOUTP.DAT',FRead);
    End
    Else
    Begin
      ErrorOut('SWCImageLoad: Fehler beim Erstellen '+
      'der Datei mit dem Ausgabepfad',000,'',#000);
      IOResult2:=002;
    End;
  End;
  If IOResult2=000 Then
  Begin
    ReadLnS(HandT,IPath,SizeOf(IPath));
    OFileT(HandT,'',FClose);
    OptionsR(000,000,
    'Whlen Sie nun bitte mit der <LEERTASTE> '+
    'die Imagedateien aus, deren Dateibeschrei'+
    'bungen ich laden soll. Je mehr Dateien Si'+
    'e whlen, umso lnger dauert der Ladeproz'+
    'e. Drcken Sie nach der Auswahl <ENTER>.',
    '~WeiterE~xit','W',BT);
    If Not BooleanEx Then
    Begin
      DH0:=255;
      Dir(DH0,IPATH+'\*.7WI',DIRZURUECK,063,LLine,BF,BF,BF);
      If BooleanErr Then
      ErrorOut('SWCImageLoad: Keine .7WI-Dateien gefunden',000,'',#000)
      Else
      If Boolean13 Then
      Begin
        LLine:=IndexLine;
        HelpCheckChoosed;
        OFileF(HandF,PRGPATH+'\7WCLOAD.LSN',FNew,001);
        If IOResult2=000 Then
        Begin
          Word0:=094;
          BlockWrite(HandF,Word0,002,CntrHROW0);
          Stri0:='  Dateiname  Kommentar zu dieser Datei  '+
          '                                                      ';
          BlockWrite(HandF,Stri0[001],094,CntrHROW0);
          Stri0:='  00000000  0000000000000000000000000000'+
          '0000000000000000000000000000000000000000000000000000  ';
          Stri0:=FillString(Stri0,#048,#000);
          BlockWrite(HandF,Stri0[001],094,CntrHROW0);
          OFileF(HandF,'',FClose,001);
          LSNLoad('7WCLOAD',PRGPATH+'\7WCLOAD.LSN','',RdWr);
          If Not BooleanErr Then
          Begin
            TempI;
            Cntr:=000;
            SHWB0:=BT;
            Long1:=000;
            For Long0:=000 To DirEA[DH0] Do
            Begin
              ShowP('Lade Image-Header ...',
              SHWB0,SHWH0,030,025,007,Long0,DirEA[DH0],BF);
              If GetFileChoo(DH0,Long0) Then
              Begin
                GetFileName(DH0,Long0,FName);
                FSplit(FName,DStr,NStr,EStr);
                Stri0:=HelpGetComment(FName);
                If Stri0<>'' Then
                Begin
                  Inc(Cntr);
                  If Long1>000 Then
                  ListInsLine('7WCLOAD',Long1,'');
                  PutListStr('7WCLOAD',Long1,000,NStr);
                  PutListStr('7WCLOAD',Long1,001,Stri0);
                  Inc(Long1);
                End;
              End;
            End;
            LSNFree('7WCLOAD');
            TempO;
            If Cntr>000 Then
            Begin
              LSNEdit('7WCLOAD',000,000,070,000,
              PRGPATH+'\7WCLOAD.LSN','',$00000004,BF,000,BT,BT,BT,BT,BT,BT);
              If Boolean13 Then
              Begin
                FName:=BuendigLR(STRLSN)+'.7WI';
                UnZip(IPath+'\'+FName,PRGPATH+'\7WCLOAD.TMP');
                OFileF(HandF,PRGPATH+'\7WCLOAD.TMP',FRead,001);
                If IOResult2=000 Then
                Begin
                  TempI;
                  SHWB0:=BT;
                  Long0:=000;
                  If XMSLA>000 Then
                  XMSFreeByHandle(XMSH0);
                  XMSH0:=XMSGetHandle('7WCLOAD.TMP',FileSize(HandF));
                  Repeat
                    ShowP('Lade '+FName+' in XMS-Speicher',
                    SHWB0,SHWH0,040,020,007,FilePos(HandF),FileSize(HandF)-001,BF);
                    BlockRead(HandF,Mem[DataS:DataO+0],8192,CntrHROW0);
                    With XMSMOVSTRUC Do
                    Begin
                      HandleS:=000;
                      XMSLen:=CntrHROW0;
                      Ptr0:=Ptr(DataS,DataO+$0000);
                      Move(Ptr0,OffsS,004);
                      HandleT:=XMSHANDLE;
                      OffsT:=XMSOFFSETS[XMSGHand2(XMSH0)]+Long0;
                      XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
                    End;
                    Inc(Long0,CntrHROW0);
                  Until EOF(FVarF,HandF);
                  ShowP('Lade '+FName+' in XMS-Speicher',
                  SHWB0,SHWH0,040,020,007,FilePos(HandF),FileSize(HandF)-001,BF);
                  OFileF(HandF,'',FClose,001);
                  XMSLA:=Long0;
                  BErr:=BF;
                  TempO;
                  PGXLoad('GETNAME','ONELINEG',
                  PRGPATH+'\7WCNAME.DAT','',000,001);
                  If Not BooleanErr Then
                  Begin
                    FSplit(FName,DStr,NStr,EStr);
                    FillField('GETNAME',000,NStr);
                    SaveRec('GETNAME',BT);
                    PGXFree('GETNAME');
                  End;
                  Stri0:=BuendigLR(LComm);
                  If Stri0<>'' Then
                  Begin
                    PGXLoad('GETCOMM','ONELINEK',
                    PRGPATH+'\7WCCOMM.DAT','',000,001);
                    If Not BooleanErr Then
                    Begin
                      FillField('GETCOMM',000,Stri0);
                      SaveRec('GETCOMM',BT);
                      PGXFree('GETCOMM');
                    End;
                  End;
                End;
                OFileT(HandT,PRGPATH+'\7WCLOAD.TMP',FErase);
              End;
            End
            Else
            ErrorOut('Keine Dateien ausgewhlt, '+
            'falsches Format oder beschdigte Datei',000,'',#000);
          End
          Else
          ErrorOut('SWCImageLoad: Fehler beim Laden der Dateiliste',000,'',#000);
        End
        Else
        ErrorOut('SWCImageLoad: Fehler beim Erstellen der Dateiliste',000,'',#000);
        DirFree(DH0);
      End;
    End;
  End;
  BooleanErr:=BErr;

End;




Procedure SWCImageSave;
Var
  BErr  : Bool;
  Byte0 : Byte;
  DStr  : ST67;
  EStr  : ST04;
  HandF : Hand;
  HandT : Hand;
  Long0 : IntL;
  LW    : ST02;
  NStr  : ST08;
  OPath : ST79;
  Stri0 : STFF;
  Word0 : Word;
  Word1 : Word;

Function  HelpGetComment: ST80;
Begin
  With XMSMOVSTRUC Do
  Begin
    XMSLen:=256;
    HandleT:=000;
    Ptr0:=Ptr(DataS,DataO+$0000);
    Move(Ptr0,OffsT,004);
    HandleS:=XMSHANDLE;
    OffsS:=XMSOFFSETS[XMSGHand2(XMSH0)];
    XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
    Move(Mem[DataS:DataO+000],Stri0,256);
    Byte0:=Pos('Comment=',Stri0);
    If Byte0=000 Then
    HelpGetComment:=''
    Else
    HelpGetComment:=Copy(Stri0,Byte0+008,080);
  End;
End;

Procedure HelpSetComment(CStr: STFF);
Begin
  BooleanErr:=BT;
  With XMSMOVSTRUC Do
  Begin
    HelpGetComment;
    Byte0:=Pos('Mediatype=',Stri0);
    If Byte0>000 Then
    Begin
      CStr:='Comment='+CStr;
      Move(CStr[001],Mem[DataS:DataO+Byte0+018],Length(CStr));
      XMSLen:=256;
      HandleS:=000;
      Ptr0:=Ptr(DataS,DataO+$0000);
      Move(Ptr0,OffsS,004);
      HandleT:=XMSHANDLE;
      OffsT:=XMSOFFSETS[XMSGHand2(XMSH0)];
      XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
      BooleanErr:=BF;
    End
    Else
    ErrorOut('SWCImageSave: Header fehlerhaft',000,'',#000);
  End;
End;

Begin

  BErr:=BT;
  If XMSLA>000 Then
  Begin
    OFileT(HandT,PRGPATH+'\7WCOUTP.DAT',FRead);
    If IOResult2=002 Then
    Begin
      OFileT(HandT,PRGPATH+'\7WCOUTP.DAT',FNew);
      If IOResult2=000 Then
      Begin
        WriteLn(HandT,PRGPATH);
        OFileT(HandT,'',FClose);
        OFileT(HandT,PRGPATH+'\7WCOUTP.DAT',FRead);
      End
      Else
      Begin
        ErrorOut('SWCImageSave: Fehler beim Erstellen '+
        'der Datei mit dem Ausgabepfad',000,'',#000);
        IOResult2:=002;
      End;
    End;
    If IOResult2=000 Then
    Begin
      ReadLnS(HandT,OPath,SizeOf(OPath));
      OFileT(HandT,'',FClose);
      Stri0:=HelpGetComment;
      PGXLoad('GETCOMM','ONELINEK',
      PRGPATH+'\7WCCOMM.DAT','',000,001);
      If Not BooleanErr Then
      Begin
        If Stri0<>'' Then
        FillField('GETCOMM',000,BuendigLR(Stri0));
        MoveTXTToScreen('GETCOMM',002,001,
        'Geben Sie einen kurzen Kommentar zu diesem Image ein,');
        MoveTXTToScreen('GETCOMM',006,005,
        'drcken Sie dann <ENTER>, oder <ESC> fr Exit ...');
        MoveColToScreen('GETCOMM',002,005,055,078);
        PGXEdit('GETCOMM','ONELINEK',
        PRGPATH+'\7WCCOMM.DAT','',009,007,BT,000,BT,BT);
        If Boolean13 Then
        Begin
          Stri0:=BuendigL2(080,EditorField);
          HelpSetComment(Stri0);
          If Not BooleanErr Then
          Begin
            PGXLoad('GETNAME','ONELINEG',
            PRGPATH+'\7WCNAME.DAT','',000,001);
            If Not BooleanErr Then
            Begin
              MoveTXTToScreen('GETNAME',002,001,
              'Geben Sie einen max. 8 Zeichen langen Dateinamen ein,');
              MoveTXTToScreen('GETNAME',006,005,
              'drcken Sie dann <ENTER>, oder <ESC> fr Exit ...');
              MoveColToScreen('GETNAME',002,005,055,078);
              PGXEdit('GETNAME','ONELINEG',
              PRGPATH+'\7WCNAME.DAT','',009,007,BT,000,BT,BT);
              If Boolean13 Then
              If EditorField<>'' Then
              Begin
                FSplit(EditorField,DStr,NStr,EStr);
                OPath:=OPath+'\'+NStr+'.7WI';
                OFileF(HandF,OPath,FRead,001);
                If IOResult2=000 Then
                Begin
                  OFileF(HandF,'',FClose,001);
                  OptionsR(000,000,
                  'Das Image '+NStr+EStr+' gibt es schon. '+
                  'Soll ich es berschreiben ?',
                  '~Ja~Nein','N',BT);
                End
                Else
                Char0:='J';
                If Char0='J' Then
                Begin
                  OFileF(HandF,OPath,FNew,001);
                  If IOResult2=000 Then
                  Begin
                    Long0:=000;
                    Repeat
                      With XMSMOVSTRUC Do
                      Begin
                        XMSLen:=8192;
                        If Long0+XMSLen>XMSLA Then
                        XMSLen:=XMSLA-Long0;
                        HandleT:=000;
                        Ptr0:=Ptr(DataS,DataO+$0000);
                        Move(Ptr0,OffsT,004);
                        HandleS:=XMSHANDLE;
                        OffsS:=XMSOFFSETS[XMSGHand2(XMSH0)]+Long0;
                        XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
                        BlockWrite(HandF,Mem[DataS:DataO+0],XMSLen,CntrHROW0);
                        Inc(Long0,XMSLen);
                      End;
                    Until Long0>=XMSLA;
                    OFileF(HandF,'',FClose,001);
                    Zip(OPath,OPath,BT,BT);
                    BErr:=BF;
                  End
                  Else
                  ErrorOut('Fehler beim Erstellen von '+NStr+'.7WI',000,'',#000);
                End;
              End;
            End;
          End;
        End;
      End;
    End
    Else
    ErrorOut('SWCImageSave: Fehler beim ffnen '+
    'der Datei mit dem Ausgabepfad',000,'',#000);
  End
  Else
  ErrorOut('Es befindet sich kein Image im Speicher',000,'',#000);
  BooleanErr:=BErr;

End;




Procedure SWCInfo;
Var
  Char1 : Char;
  Stri0 : ST80;
  Stri1 : ST80;
  Stri2 : ST80;
  Stri3 : ST80;
  Stri4 : ST80;
  Stri5 : ST80;
  Stri6 : ST80;
  Stri7 : ST80;
  Stri8 : ST80;

Begin

  Char1:='E';
  ScreenParams(BT);
  Repeat
    OptTableau3(000,000,074,006,'',BF);
    Str(DataKB,Stri0);
    Str(MaxTrys,Stri1);
    Str(XMSLA,Stri2);
    Stri3:=SWCOPathGet;
    Str(XMSMyBlock,Stri4);
    Str(GetFreeMem*016 Div 1024,Stri7);
    Stri5:='$'+GetHexToStr(Hi(DataS))+GetHexToStr(Lo(DataS));
    Stri6:='$'+GetHexToStr(Hi(SWCSegLimitGet))+GetHexToStr(Lo(SWCSegLimitGet));
    Stri0:=Stri0+' Segment '+Stri5;
    Stri8:='Arbeitsspeicher in KB (Frei '+Stri7+'): '+Stri0;
    WriteVR('          Version von 7Ware-Copy: 1.1 (C) 2003 Karl Lindfeld',003,002);
    WriteVR(Stri8,006-Length(Stri7),003);
    WriteVR('  Verfgbarer XMS-Speicher in KB: '+Stri4,003,004);
    WriteVR('Gre des Images im XMS Speicher: '+Stri2+' Byte',003,005);
    WriteVR('    Anzahl Lese- Schreibversuche: '+Stri1,003,006);
    WriteVR('      Aktueller Aus- Eingabepfad: '+CutString(Stri3,039),003,007);
    OptionsR(026,011,
    'Men Info',
    'Men ~Einstellungen'+
    'XMS ~Speicher ansehen'+
    'E~xit',Char1,BF);
    If Not BooleanEx Then
    Begin
      Char1:=Char0;
      If Char0='E' Then
      SWCAdjustments
      Else
      If Char0='S' Then
      SWCXMSEdit;
      WaitClr;
    End;
  Until BooleanEx;
  ScreenParams(BF);

End;




Procedure SWCMainMenue;
Var
  Char1 : Char;

Begin

  Char1:='E';
  ScreenParams(BT);
  Repeat
    OptionsR(000,000,
    'Was mchten Sie nun tun ?',
    'Diskette ~einlesen (Image erzeugen)'+
    'Diskette er~zeugen (Aus Image)'+
    'Diskettenimage ~laden'+
    'Diskettenimage ~speichern'+
    '~Info + mehr ...'+
    'E~xit, Programm beenden',Char1,BT);
    If Not BooleanEx Then
    Begin
      Char1:=Char0;
      If Char0='E' Then
      Begin
        SWCDiskReadIn;
        If Not BooleanErr Then
        Char1:='S'
        Else
        XMSLA:=000;
      End
      Else
      If Char0='Z' Then
      Begin
        SWCDiskMake;
        If Not BooleanErr Then
        Char1:='L';
      End
      Else
      If Char0='L' Then
      Begin
        SWCImageLoad;
        If Not BooleanErr Then
        Char1:='Z';
      End
      Else
      If Char0='S' Then
      Begin
        SWCImageSave;
        If Not BooleanErr Then
        Char1:='E';
      End
      Else
      If Char0='I' Then
      SWCInfo;
      WaitClr;
    End
    Else
    OptionsR(000,000,
    '7Ware-Copy wirklich beenden ?',
    '~Ja~Nein','N',BT);
    If Char0='J' Then
    BooleanEx:=BT;
  Until BooleanEx;
  ScreenParams(BF);

End;




Procedure SWCMakeHexLSN(HPath: ST79);
Var
  AByte  : Array[000..007] Of Byte;
  Bool0  : Bool;
  Byte0  : Byte;
  Byte1  : Byte;
  HandF0 : Hand;
  HandF1 : Hand;
  HStr   : ST02;
  Long0  : IntL;
  Long1  : IntL;
  Long2  : IntL;
  LSNLn  : STFF;
  Stri0  : STFF;
  Word0  : Word;
  Word1  : Word;
  SHWB0  : Bool;
  SHWH0  : Byte;

Begin

  TempI;
  Bool0:=BF;
  BooleanErr:=BT;
  OptionsR(000,000,
  'Zeichen mitdarstellen ?',
  '~Alle'+
  '~Reduziert'+
  '~Keine'+
  'E~xit','A',BT);
  If Not BooleanEx Then
  Begin
    Case Char0 Of
    'A' : HP0:=HPAll;
    'R' : Begin
            Bool0:=BT;
            HP0:=HPRed;
          End;
    'K' : Begin
            Bool0:=BT;
            HP0:=HPNone;
          End;
    End;
    OFileF(HandF0,HPath,FRead,001);
    If IOResult2=000 Then
    Begin
      OFileF(HandF1,PRGPATH+'\7WCHEXL.TMP',FNew,001);
      If IOResult2=000 Then
      Begin
        Word0:=054;
        BlockWrite(HandF1,Word0,002,CntrHROW0);
        FillChar(Stri0[001],054,000);
        Stri0:='  '+CutString(HPath,050);
        BlockWrite(HandF1,Stri0[001],054,CntrHROW0);
        Long2:=FileSize(HandF0);
        Long1:=$00000000;
        SHWB0:=BT;
        Repeat
          ShowP('Schreibe Hex-Datei',SHWB0,
          SHWH0,030,025,007,FilePos(HandF0),Long2,BF);
          Long0:=Long1;
          Inc(Long1,008);
          LSNLn:='  ';
          For Byte1:=000 To 003 Do
          Begin
            Byte0:=000;
            Byte0:=Byte0 Or Long0;
            Long0:=Long0 Shr 008;
            AByte[Byte1]:=Byte0;
          End;
          For Byte1:=003 DownTo 000 Do
          LSNLn:=LSNLn+GetHexToStr(AByte[Byte1]);
          LSNLn:=LSNLn+'  ';
          BlockRead(HandF0,AByte,008,Word1);
          If Word1>000 Then
          For Byte0:=000 To Word1-001 Do
          LSNLn:=LSNLn+GetHexToStr(AByte[Byte0])+'  ';
          If Word1>000 Then
          For Byte1:=Byte0+001 To 007 Do
          LSNLn:=LSNLn+#000+#000+'  '
          Else
          For Byte1:=000 To 007 Do
          LSNLn:=LSNLn+#000+#000+'  ';
          If Word1>000 Then
          For Byte0:=000 To Word1-001 Do
          If Bool0 Then
          Begin
            If HP0=HPRed Then
            Begin
              If AByte[Byte0]<033 Then
              LSNLn:=LSNLn+#046 Else
              LSNLn:=LSNLn+Chr(AByte[Byte0]);
            End
            Else
            LSNLn:=LSNLn+#046;
          End
          Else
          Begin
            If AByte[Byte0]=032 Then
            LSNLn:=LSNLn+#000 Else
            LSNLn:=LSNLn+Chr(AByte[Byte0]);
          End;
          If Bool0 Then
          Begin
            If Word1>000 Then
            For Byte1:=Byte0+001 To 007 Do
            LSNLn:=LSNLn+#046
            Else
            For Byte1:=000 To 007 Do
            LSNLn:=LSNLn+#046;
          End
          Else
          Begin
            If Word1>000 Then
            For Byte1:=Byte0+001 To 007 Do
            LSNLn:=LSNLn+#000
            Else
            For Byte1:=000 To 007 Do
            LSNLn:=LSNLn+#000;
          End;
          LSNLn:=LSNLn+'  ';
          BlockWrite(HandF1,LSNLn[001],054,CntrHROW0);
        Until EOF(FVarF,HandF0);
        OFileF(HandF1,'',FClose,000);
        ShowPClr(SHWH0);
        BooleanErr:=BF;
      End
      Else
      ErrorOut('SWCMakeHexLSN: 7WCHEXL.TMP: '+
      GetDOSError(IOResult2),000,'',#000);
      OFileF(HandF0,'',FClose,000);
    End
    Else ErrorOut('SWCMakeHexLSN: '+HPath+
    ': '+GetDOSError(IOResult2),000,'',#000);
  End;
  TempO;

End;




Procedure SWCMaxTrysGet;
Begin

  MaxTrys:=003;
  PGXLoad('GETMTRYS','ONELINEG',
  PRGPATH+'\7WCADJT.DAT','',000,001);
  If Not BooleanErr Then
  Begin
    If GetFieldStr('GETMTRYS',000,000)='' Then
    Begin
      FillField('GETMTRYS',000,'3');
      SaveRec('GETMTRYS',BT);
    End;
    MaxTrys:=GetFieldByte('GETMTRYS',000);
    PGXFree('GETMTRYS');
  End;

End;




Function  SWCOPathGet: ST79;
Begin

  PGXLoad('GETOPATH','ONELINEG',
  PRGPATH+'\7WCOUTP.DAT','',000,001);
  If Not BooleanErr Then
  Begin
    If GetFieldStr('GETOPATH',000,000)='' Then
    Begin
      FillField('GETOPATH',000,PRGPATH);
      SaveRec('GETOPATH',BT);
    End
    Else
    Begin
      If Not ChkPath(GetFieldStr('GETOPATH',000,128)) Then
      Begin
        If SWCSubPr.
        ChkDrvOk(Copy(GetFieldStr('GETOPATH',000,128),001,001)) Then
        MakePath(GetFieldStr('GETOPATH',000,128))
        Else
        Begin
          FillField('GETOPATH',000,PRGPATH);
          SaveRec('GETOPATH',BT);
        End;
      End;
    End;
    SWCOPathGet:=GetFieldStr('GETOPATH',000,128);
    PGXFree('GETOPATH');
  End;

End;




Procedure SWCSaveHexLSN(HPath: ST79);
Var
  ASeg  : Word;
  CntrA : Word;
  CntrT : Byte;
  HandF : Hand;
  I     : Byte;
  Long0 : IntL;
  SHWB0 : Bool;
  SHWH0 : Byte;
  Stri0 : ST80;
  Stri1 : ST02;
  Word0 : Word;
  Word1 : Word;

Begin

  OFileF(HandF,HPath,FNew,001);
  If IOResult2=000 Then
  Begin
    TempI;
    SHWB0:=BT;
    CntrA:=000;
    CntrT:=001;
    Stri0[000]:=#032;
    I:=LSNIGet('HEXEDI');
    ASeg:=GetBuf(8192,Word0,Word1);
    MemErrorOut('SWCSaveHexLSN',Word0,000);
    For Long0:=000 To LastLine[I] Do
    Begin
      ShowP('Schreibe Datei neu',
      SHWB0,SHWH0,030,025,007,Long0,LastLine[I],BF);
      ReadOneLine('HEXEDI',Long0);
      Move(Mem[LineSeg[I]:012],Stri0[001],032);
      Stri0:=FillString(Stri0,#000,#032);
      Repeat
        Stri1:=BuendigLR(Copy(Stri0,004*CntrT-003,002));
        If Stri1<>'' Then
        Begin
          Mem[ASeg:CntrA]:=GetStrToHex(Stri1);
          Inc(CntrA);
        End;
        Inc(CntrT);
      Until (CntrA=8192) Or (CntrT=009);
      If CntrA=8192 Then
      Begin
        BlockWrite(HandF,Mem[ASeg:0],CntrA,CntrHROW0);
        CntrA:=000;
      End;
      If CntrT=009 Then CntrT:=001;
    End;
    If CntrA>000 Then
    BlockWrite(HandF,Mem[ASeg:0],CntrA,CntrHROW0);
    OFileF(HandF,'',FClose,000);
    FreeBuf(ASeg,Word0);
    MemErrorOut('SWCSaveHexLSN',Word0,000);
    TempO;
  End
  Else ErrorOut('SWCSaveHexLSN: '+
  HPath+': '+GetDOSError(IOResult2),000,'',#000);

End;




Function  SWCSegLimitGet: Word;
Var
  Stri0 : ST10;
  Word0 : Word;

Begin

  SWCSegLimitGet:=$0000;
  PGXLoad('ADJSTSEG','ONELINEG',
  PRGPATH+'\7WCADJSG.DAT','',000,001);
  If Not BooleanErr Then
  Begin
    Word0:=GetFieldWord('ADJSTSEG',000);
    Stri0:='$'+GetHexToStr(Hi(Word0))+GetHexToStr(Lo(Word0));
    FillField('ADJSTSEG',000,Stri0);
    SaveRec('ADJSTSEG',BT);
    SWCSegLimitGet:=Word0;
    PGXFree('ADJSTSEG');
  End;

End;




Procedure SWCXMSEdit;
Label LOOP2;

Var
  HandF : Hand;
  Long0 : IntL;

Begin

  If XMSLA>000 Then
  Begin
    OFileF(HandF,PRGPATH+'\7WCHEXB.TMP',FNew,001);
    If IOResult2=000 Then
    Begin
      Long0:=000;
      Repeat
        With XMSMOVSTRUC Do
        Begin
          XMSLen:=8192;
          HandleT:=000;
          If XMSLen+Long0>XMSLA Then
          XMSLen:=XMSLA-Long0;
          HandleS:=XMSHANDLE;
          Ptr0:=Ptr(DataS,DataO+$0000);
          Move(Ptr0,OffsT,004);
          OffsS:=XMSOFFSETS[XMSGHand2(XMSH0)]+Long0;
          XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
          BlockWrite(HandF,Mem[DataS:DataO+0],XMSLen,CNTRHROW0);
          Inc(Long0,XMSLen);
        End;
      Until Long0>=XMSLA;
      OFileF(HandF,'',FClose,001);
      SWCMakeHexLSN(PRGPATH+'\7WCHEXB.TMP');
      If Not BooleanErr Then
      Begin
        LOOP2:
        LSNEdit('HEXEDI',000,000,000,000,
        PRGPATH+'\7WCHEXL.TMP','',$00010009,
        BF,000,BF,BF,BT,BT,BT,BT);
        OptionsR(000,000,
        'Daten in XMS Speicher zurck schreiben ?',
        '~Ja~NeinE~xit, Abbruch','N',BT);
        If Char0='J' Then
        Begin
          SWCSaveHexLSN(PRGPATH+'\7WCHEXB.TMP');
          OFileF(HandF,PRGPATH+'\7WCHEXB.TMP',FRead,001);
          If IOResult2=000 Then
          Begin
            Long0:=000;
            Repeat
              With XMSMOVSTRUC Do
              Begin
                XMSLen:=8192;
                BlockRead(HandF,Mem[DataS:DataO+0],XMSLen,CNTRHROW0);
                HandleS:=000;
                XMSLen:=CntrHROW0;
                HandleT:=XMSHANDLE;
                Ptr0:=Ptr(DataS,DataO+$0000);
                Move(Ptr0,OffsS,004);
                OffsT:=XMSOFFSETS[XMSGHand2(XMSH0)]+Long0;
                XMSCallFunc(XMSGHand2(XMSH0),MoveEMB);
                Inc(Long0,XMSLen);
              End;
            Until EOF(FVarF,HandF);
            OFileF(HandF,'',FClose,001);
          End;
        End
        Else
        If BooleanEx Then
        Goto LOOP2;
        LSNFree('HEXEDI');
        OFileF(HandF,PRGPATH+'\7WCHEXB.TMP',FErase,001);
        OFileF(HandF,PRGPATH+'\7WCHEXL.TMP',FErase,001);
      End;
    End;
  End
  Else
  ErrorOut('Kein Image im Speicher',000,'',#000);

End;




END.
